''File: APRS_Packet_Generator

'' Created 04/10/14
'' Based off code written by G3CWI-Richard

VAR''----------------------------------------------------------------------------------------

  Byte Packet[150]    
  Byte PacketLength
   

OBJ''----------------------------------------------------------------------------------------                          

  mdm           : "Bell202_Modem_Mod"  


PUB Generate(CallSign, SSID, HighLat, LowLat, HighLong, LowLong, Head, Knots, Alt) | val1, val2'' 

'Clear Packet

  bytefill(@Packet, 0, 150)
  PacketLength := 0                                  

'Destination Address

  AddString(string("CQ    "), 6)
  AddNumber(0, 1)                                       'SSID = 0                 

'Source Address

  AddString(CallSign, 6)                                'Callsign must be six characters 
  AddNumber(SSID, 1)                                    
     
'Digipeater Addresses

  AddString(string("WIDE1 "), 6)
  AddNumber(1, 1)                                       'SSID = 1     

  AddString(string("WIDE2 "), 6)
  Packet[PacketLength++] := %01100011                   'SSID = 2 (01100001 on <00000010). It's wierd.   
    
'Shift Bits

  Val1 := 0
  repeat PacketLength -1                                'Dont Shift Wide2 SSID
    Packet[Val1++] <<= 1

'Control Field

  Packet[PacketLength++] := $03                         'Control byte                              

'Protocol ID 
      
  Packet[PacketLength++] := $F0                         'Protocol ID

'Timestamp
  
  AddString(string("!"), 1)  

'Latitude

  val1 := LowLat*6                                      'Convert LowLat to decimal minutes
  val1 := val1/10000
  val1 := val1*100
  val2 := LowLat*6
  val2 := val2/100
  val2 := val2-val1
  val1 := val1/100

  If HighLat <  0
    AddNumber(-1*HighLat, 2)
  If HighLat => 0                             
    AddNumber(HighLat, 2) 
  AddNumber(Val1, 2)
  AddString(string("."), 1)
  AddNumber(Val2, 2)                           
  If HighLat < 0
    AddString(string("S/"), 2)
  If HighLat => 0        
    AddString(string("N/"), 2)
  
'Longitude                        

  val1 := LowLong*6                                     'Convert LowLong to decimal minutes
  val1 := val1/10000
  val1 := val1*100
  val2 := LowLong*6
  val2 := val2/100
  val2 := val2-val1
  val1 := val1/100

  If HighLong < 0
    AddNumber(-1*HighLong, 3)
  If HighLong => 0             
    AddNumber(HighLong, 3) 
  AddNumber(Val1, 2)
  AddString(string("."), 1)
  AddNumber(Val2, 2)                               
  If HighLong < 0
    AddString(string("W"), 1)
  If HighLong => 0         
    AddString(string("E"), 1)
 
'Icon

'  AddString(string("'"), 1)                             'Small Aircraft 
  AddString(string(">"), 1)                             'Car    

'Course

  AddNumber(Head, 3)                                    '000 means station is fixed
  AddString(string("/"), 1)
      
'Speed

  AddNumber(Knots, 3)                               
  
'Altitude

  Alt := Alt * 3281                                     'Convert meters to feet
  Alt := Alt / 1000

  AddString(string("/A="), 3)
  AddNumber(Alt, 6)


PUB Add_Data(Temp, mbar, TX_Sigma)''-------------------------------------------------

  Temp  := Temp/10   
  mbar  := mbar/100
  If mbar => 999
    mbar := 999

'Temperature

  AddString(string(",T="), 3) 
  AddNumber(Temp, 2)                      

'Pressure
     
  AddString(string(",P="), 3)
  AddNumber(mbar, 3)
  
'TX_Sigma
  
  AddString(string(","), 1)
  If TX_Sigma => 1000      
    AddNumber(TX_Sigma, 4)    
  If TX_Sigma => 100 and TX_Sigma < 1000       
    AddNumber(TX_Sigma, 3)
  If TX_Sigma => 10 and TX_Sigma < 100       
    AddNumber(TX_Sigma, 2)
  If TX_Sigma < 10      
    AddNumber(TX_Sigma, 1)
     
  
PUB AddString(Address, ByteCnt) ''-----------------------------------------------------------

  repeat ByteCnt
    Packet[PacketLength++] := byte[Address++]

    
PUB AddNumber(Number, ByteCnt) | n1s, n10s, n100s, n1000s, n10000s, n100000s, a, c ''--------  

  c := Number

  If c  > 999999
     c := 999999

  If c  < 0
     c := 0     

  n100000s := c / 100000                    
  a := n100000s * 100000                     
  c := number - a                                    
      
  n10000s := c / 10000   
  a := n10000s * 10000    
  c := c - a                   

  n1000s := c / 1000        
  a := n1000s * 1000         
  c := c - a                   

  n100s := c / 100         
  a := n100s * 100             
  c := c - a                  

  n10s := c / 10             
  a := n10s * 10                 
  c := c - a                  

  n1s := c                 

  If ByteCnt == 1
    NumberToPacket(n1s) 

  If ByteCnt == 2
    NumberToPacket(n10s)        
    NumberToPacket(n1s)

  If ByteCnt == 3
    NumberToPacket(n100s)      
    NumberToPacket(n10s)        
    NumberToPacket(n1s)

  If ByteCnt == 4
    NumberToPacket(n1000s)
    NumberToPacket(n100s)      
    NumberToPacket(n10s)        
    NumberToPacket(n1s)

  If ByteCnt == 5
    NumberToPacket(n10000s) 
    NumberToPacket(n1000s)
    NumberToPacket(n100s)      
    NumberToPacket(n10s)        
    NumberToPacket(n1s)

  If ByteCnt == 6
    NumberToPacket(n100000s)
    NumberToPacket(n10000s) 
    NumberToPacket(n1000s)
    NumberToPacket(n100s)      
    NumberToPacket(n10s)        
    NumberToPacket(n1s)

    
PUB NumberToPacket(Val)''-------------------------------------------------------------------- 

  If Val == 0                     
    AddString(string("0"),1)  
  If Val == 1
    AddString(string("1"),1)
  If Val == 2
    AddString(string("2"),1)
  If Val == 3
    AddString(string("3"),1)
  If Val == 4
    AddString(string("4"),1)
  If Val == 5
    AddString(string("5"),1)
  If Val == 6
    AddString(string("6"),1)
  If Val == 7
    AddString(string("7"),1)
  If Val == 8
    AddString(string("8"),1)
  If Val == 9
    AddString(string("9"),1)                                

    
pub ComputeFCS | i''-------------------------------------------------------------------------  

  i:=0 

  result := $ffff
  repeat PacketLength
    result ^= Packet[i++] 
    repeat 8
      if result & 1
        result := (result >> 1) ^ $8408
      else
        result >>= 1
  result ^= $ffff


PUB Transmit(XMTpin) | FCS, i''--------------------------------------------------------------

'Frame Check Sequence

  FCS := ComputeFCS
  Packet[PacketLength++] := FCS&$ff                
  Packet[PacketLength++] := FCS>>8 

'Start Modem  

  mdm.start_simple(0, XMTpin, 0, 15)                    '(rcvpin, xmtpin, pttpin, mode)
  waitcnt(clkfreq/20 + cnt)                            'Give modem time to settle in                             
  mdm.transmit                                          'Take modem to transmit

'Send Data

  i:=0 
  mdm.out($7e)                                          'AX.25 UI-frame start/stop flag     
  repeat PacketLength                                   'Send data bytes
    mdm.out(Packet[i++])
  mdm.out($7e)                                          'AX.25 UI-frame start/stop flag     

'Stop Modem
  
  mdm.standby                                           'Take modem to standby
  mdm.stop                                              'Stop modem

  Return PacketLength
    
''-------------------------------------------------------------------------------------------